C                     Aum Sri Sairam
C     
C     -*--*--*--*--*--*--*--*--*--*--*--*--*--*--*--*--*--*--*--*--*-
C     
C     
C     Copyright M.Murugananth
C     Phase Transformation and Complex Properties Group
C     Department of Material Science and Metallurgy 
C     University Of Cambridge
C     
C     -*--*--*--*--*--*--*--*--*--*--*--*--*--*--*--*--*--*--*--*--*-
C
C     TO CALL THE MTDATA AS SLAVE
C
C    ~*~~*~~*~~*~~*~~*~~*~~*~~*~~*~~*~~*~~*~~*~~*~~*~~*~~*~~*~~*~~*~
C    CALCULATES PPT FRACTION, WEIGHT PERCENTAGE OF SOLID SOLUTION 
C    STRENGTHENING ELEMENTS, AND THE INSTABILITY PARAMETER
C    ~*~~*~~*~~*~~*~~*~~*~~*~~*~~*~~*~~*~~*~~*~~*~~*~~*~~*~~*~~*~~*~
C                        15th Jan 2002
C
C
C
C     
C***************************************************************
C     
C     ------------------------------------------------------------
C     Variables and functions used in this program that are called 
C     from the MTDATA application
C     ------------------------------------------------------------
C     
C     
C     
C     OPEN_MPI_FILE(FILE1, FILE2,IERR)
C     SET_PRINT_LEVEL(WEIGHT_TABLE)
C     SET_TEMPERATURE(873.0D0)
C     SET_PRESSURE(101325.0D0)
C     SET_SYSTEM_WEIGHT(1.0D0)
C     INIT_NO_OF_COMPONENTS()
C     INIT_COMPONENT_NAME(I)
C     SET_INIT_COMPONENT_MASS(I,AMOUNT1)
C     SET_INIT_PHASE_CLASS(I2,NORMAL)
C     NUMBER_OF_ERRORS()
C     INIT_COMPONENT_MOLES(I)
C     INIT_COMPONENT_MASS(I)
C     SUM_OF_COMPONENT_AMOUNT()
C     SUM_OF_COMPONENT_MASS()
C     TEMPERATURE()
C     PRESSURE()
C     SYSTEM_GIBBS_ENERGY()
C     SYSTEM_ENTHALPY()
C     SYSTEM_ENTROPY()
C     SYSTEM_VOLUME()
C     PARTIAL_SYSTEM_GIBBS_ENERGY(I)
C     EQUIL_NO_OF_PHASES()
C     ACT_NO_OF_PHASES()
C     MOLES_OF_COMPONENTS_IN_PHASE(I,ACTIVE)
C     MASS_IN_PHASE(I,ACTIVE)
C     ACT_PHASE_NAME(I)
C     ACT_NO_OF_COMPONENTS()
C     COMPONENT_W_OF_PHASE(J,I,ACTIVE)
C     ACT_COMPONENT_NAME(J)
C     COMPONENT_X_OF_PHASE(J,I,ACTIVE)
C     COMPONENT_MOLES_IN_PHASE(J,I,ACTIVE)
C
C
C****************************************************************
C
C     ---------------------------------------------------
C
C     NON -MTDATA VARIABLE INCLUDED USED BY Murugananth.M
C     
C     ---------------------------------------------------
C
C
C     AR_I  defines the each composition variable
C     AR_J defines the number of lines
C     NO__OF_LINES gives the limit to the number of lines
C
C
C
C   
C****************************************************************


      PROGRAM Stability_Parameter

      
      INCLUDE'/home4/users/guest/mt472obj/DIRUSRAP.FOR'
      CHARACTER*80 FILE1, FILE2,NAME
      CHARACTER PPT_FILE*14,EXTN_NUM*3
C     IMPLICIT DOUBLE PRECISION(A-H,0-Z), INTEGER(I-N)
      DOUBLE PRECISION AMOUNT1(10000, 100), AMNT, NO_OF_PHASES
      DOUBLE PRECISION TOTAL_MOLES, MOLE_FRAC(500)
      DOUBLE PRECISION  TEMP_D(10000), SOLID_SOLN(100),HCP(100)
      INTEGER AR_I,AR_J, INC, AR_JJ, TEMP_I, NO_OF_LINES, SLNI
 
      DOUBLE PRECISION Q,R,T
      DOUBLE PRECISION Rcr,Rw,Rv,Rnb,Rmo,Rmn,Dfe,Dfe_para
      DOUBLE PRECISION bcc_cr,bcc_w,bcc_nb,bcc_mo,bcc_v,bcc_mn
      DOUBLE PRECISION m23c6_cr,m23c6_mo,m23c6_mn,m23c6_w
      DOUBLE PRECISION m6c_w,m6c_mo,laves_w,laves_mo,laves_nb,laves_cr
      DOUBLE PRECISION hcpa3_mo,hcpa3_w,hcpa3_mn,hcpa3_cr
      DOUBLE PRECISION nbc_nb,nbn_nb,nv_v
      DOUBLE PRECISION m7c3_mn, m7c3_cr,m7c3_mo
      DOUBLE PRECISION Dcr,Dw,Dv,Dnb,Dmo,Dmn,Deff,one_by_Deff
      DOUBLE PRECISION one_by_Deff_m23c6,one_by_Deff_m6c
      DOUBLE PRECISION one_by_Deff_laves,one_by_Deff_hcpa3
      DOUBLE PRECISION one_by_Deff_vn,one_by_Deff_nbc
      DOUBLE PRECISION one_by_Deff_nbn,one_by_Deff_m7c3
      DOUBLE PRECISION Deff_m23c6,Deff_m6c
      DOUBLE PRECISION Deff_laves,Deff_hcpa3
      DOUBLE PRECISION Deff_vn,Deff_nbc
      DOUBLE PRECISION Deff_nbn,Deff_m7c3




      OPEN (UNIT=1,FILE='MTDATA_OUTPUT')
      OPEN(UNIT=2,FILE='comp_data')
      OPEN(UNIT=4,FILE='temp_only')
      OPEN(UNIT=995,FILE='SOLID_SOLN')
      OPEN(UNIT=771,FILE='one_by_D_eff.dat')
      OPEN(UNIT=772,FILE='Deff.dat')

      IMODE=0
      

CC===============================================================
CC===============DIFFUSION COEFFICIENTS RATIO====================
CC==============       D_elt / D_Fe         =====================
CC===============================================================
CC   Diffusion in Iron, Jan Fridberg, Roayl inst of Technology
CC   Stockholm. Jernkpnt. Ann. 153 (1969), pp 263--268
CC===============================================================
CC===============================================================

      Rcr=3
      Rw=2.7
      Rv=3
      Rnb=3
      Rmo=2.7
      Rmn= 2
C     below 760 degC (curie temperature), units : cm^2/s

      Dfe=0.5*0.0001

C     above 760 degC (curie temperature), units : cm^2/s
      Dfe_para=1.6*0.0001

CC    Q in J / mole      

      Q=240000
      R=8.3143

CC===============================================================
CC===============================================================




      CALL INITIALISE_MTDATA(IMODE)
      CALL SGUMEN(1)
      CALL SGUMEN(7)
      
      WRITE(*,*)
      WRITE(SCREEN(),*) 'GAS CONSTANT = ', GAS_CONSTANT()
      WRITE(1,*) 'GAS CONSTANT = ', GAS_CONSTANT()
      WRITE(*,*)
      
C     CALL MTOPTN(2,'SYSTEM_RESIZE=100')
      CALL MTOPTN(2,'STAGE_1=NEW')
      
C     FILE1='test1.mpi'
      
      WRITE(*,*)'ENTER mpi FILENAME (with extn.):'
      READ (5,*) FILE1
      WRITE(*,*)'ENTER mpr FILENAME (with extn.):'
      READ (5,*) FILE2
      
C     FILE2='test1.mpi'
      IERR=0
      
C      NO_OF_LINES=1

      WRITE(*,*) 'TYPE THE NUMBER OF LINES IN THE DATABASE'
      READ(*,*) NO_OF_LINES
      WRITE (*,*) 'NUMBER OF LINES IN THE DATABASE',
     & NO_OF_LINES

      CALL OPEN_MPI_FILE( FILE1, FILE2,IERR)
      CALL SET_PRINT_LEVEL(WEIGHT_TABLE)
      TEMP_I=1
      IF (IERR .NE. 0) THEN
         WRITE(*,*) 'FAILURE IN MPI FILE READ, ERROR=',IERR
      ELSE
         DO 8989 TEMP_I=1, NO_OF_LINES
            READ(4,*) TEMP_D(TEMP_I)
            WRITE(*,*) 'JUST AFTER READING', TEMP_D(TEMP_I)
C         READ(4,*) (TEMP_D(TEMP_I),TEMP_I=1, NO_OF_LINES)
 8989    CONTINUE
         WRITE (*,*)
         WRITE (*,*)
C         WRITE(*,*) 'temperature','=',(TEMP_D(TEMP_I),
C     &    TEMP_I=1, NO_OF_LINES)
         DO 9898 TEMP_I=1, NO_OF_LINES
            WRITE (*,*) TEMP_I, TEMP_D(TEMP_I)
 9898    CONTINUE
         

         WRITE (*,*)
         WRITE (*,*)
C     CALL SET_TEMPERATURE(TEMP_D(TEMP_I))
C         WRITE (*,*) 'TEMPERATURE', (TEMP_D(AR_I), AR_I=1,NO_OF_LINES)
         CALL SET_PRESSURE(101325.0D0)
         CALL SET_SYSTEM_WEIGHT(1.0D0)

         WRITE (*,*) '---------------------------'
         WRITE (*,*) 'NO OF COMPONENTS =', INIT_NO_OF_COMPONENTS()
         WRITE (*,*) '---------------------------'
         INC=INIT_NO_OF_COMPONENTS()-1
C         WRITE (*,*) 'AFTER TEMP 1', (TEMP_D(AR_I), AR_I=1,NO_OF_LINES)
C         AMOUNT1(0,0)=999.0
         READ (2,*) ((AMOUNT1(AR_J,AR_I), AR_I=1, INC), 
     &        AR_J=1,NO_OF_LINES)

         AR_I=1
         AR_JJ=NO_OF_LINES

         WRITE (*,*) 'AFTER TEMP 4', (TEMP_D(AR_I), AR_I=1,NO_OF_LINES)

         DO 999 AR_I=1, AR_JJ
            AMNT=0
C            CALL SET_TEMPERATURE(TEMP_D(AR_JJ))
            CALL SET_TEMPERATURE(TEMP_D(AR_I))

                  WRITE(1,*)'@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@'
                  WRITE(1,*)'         COMPOSITION', AR_I
                  WRITE(1,*)'@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@'     
                  WRITE(*,*)
                  WRITE(*,*)'@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@'
                  WRITE(*,*)'         COMPOSITION', AR_I
                  WRITE(*,*)'@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@'     
                  WRITE(*,*)
                  WRITE (*,*) 'TEMPERATURE', TEMP_D(AR_I)
                  WRITE (*,*)

            DO 10 I=1, INIT_NO_OF_COMPONENTS()
C     INITIALISING THE AMOUNT OF COMPONENTS
               IF (I .NE. INIT_NO_OF_COMPONENTS()) THEN
                  WRITE(*,771) I, 
     &                 INIT_COMPONENT_NAME(I),
     &                 AMOUNT1(AR_I,I)

                  WRITE(1,771) I, 
     &                 INIT_COMPONENT_NAME(I),
     &                 AMOUNT1(AR_I,I)
                  AMNT=AMOUNT1(AR_I,I)+AMNT
C     AR_I=AR_I+1
               ELSE
                  AMOUNT1(AR_I,I)=100-AMNT
                  WRITE(*,771) I, 
     &                 INIT_COMPONENT_NAME(I)
     &                 ,AMOUNT1(AR_I,I)

                  WRITE(1,771) I, 
     &                 INIT_COMPONENT_NAME(I)
     &                 ,AMOUNT1(AR_I,I)                  
               ENDIF

               CALL SET_INIT_COMPONENT_MASS(I,AMOUNT1(AR_I,I))
 10         CONTINUE

 771        FORMAT(I5,' ', A16,' ', F10.5)

            
C     WRITE(*,*)'HOW MANY PHASES HAVE YOU DEFINED'
C     READ (5,*) NO_OF_PHASES
         
         NO_OF_PHASES=10
         
         DO 991 I2=1, NO_OF_PHASES
C            WRITE(*,*) 'phase number', I2
            CALL  SET_INIT_PHASE_CLASS(I2,NORMAL)
 991     CONTINUE
         
         
         CALL COMPUTE_EQUILIBRIUM

         
         IF (NUMBER_OF_ERRORS() .NE. 0) THEN
            
            CALL WRITE_ERROR
            
         ELSE
            
C     WRITE(*,*)
C     WRITE(*,*) 'APPLICATION OUTPUT - FOR ANANTH'
C     WRITE(*,*) '================================'
C     WRITE(*,*)
            
         
            WRITE(1,*)
            WRITE(1,*) 'APPLICATION OUTPUT - FOR ANANTH'
            WRITE(1,*) '==============================='
            WRITE(1,*)
            
            
            WRITE(*,*)'NO OF PHASES IN THE SYSTEM', INIT_NO_OF_PHASES()
C     WRITE(*,*)

            DO 40 I=1,INIT_NO_OF_COMPONENTS()
C     WRITE(*,*) 'AMOUNT OF ', INIT_COMPONENT_NAME(I),'=',
C     &              INIT_COMPONENT_MOLES(I)
               
               WRITE(1,*) 'MOLES OF ',INIT_COMPONENT_NAME(I)
     &              ,'= ', INIT_COMPONENT_MOLES(I)               
 40         CONTINUE
           

            
            DO 41 I=1, INIT_NO_OF_COMPONENTS()
C               WRITE(*,*)'MASS OF ', INIT_COMPONENT_NAME(I),'=',
C     &              INIT_COMPONENT_MASS(I)
               
               WRITE(1,*)'MASS OF ', INIT_COMPONENT_NAME(I),'=',
     &              INIT_COMPONENT_MASS(I)               
 41         CONTINUE
            

C            WRITE(*,*)
C     WRITE(*,*)'AMOUNT OF SYSTEM = ',
C     &           SUM_OF_COMPONENT_AMOUNT()
C     WRITE(*,*)'MASS OF SYSTEM = ',SUM_OF_COMPONENT_MASS()
C     WRITE(*,*)
            WRITE(1,*)
            WRITE(1,*)'AMOUNT OF SYSTEM = ',
     &           SUM_OF_COMPONENT_AMOUNT()
            WRITE(1,*)'MASS OF SYSTEM = ',SUM_OF_COMPONENT_MASS()
            WRITE(1,*)
            WRITE(*,*) 'TEMPERATURE  =', TEMPERATURE()
C            WRITE(*,*) 'PRESSURE     =', PRESSURE()
C            WRITE(*,*)
C            WRITE(*,*) 'SYSTEM GIBBS ENERGY  =', SYSTEM_GIBBS_ENERGY()
C            WRITE(*,*) 'SYSTEM ENTHALPY      =',SYSTEM_ENTHALPY()
C            WRITE(*,*) 'SYSTEM ENTROPY       =', SYSTEM_ENTROPY()
C            WRITE(*,*) 'SYSTEM VOLUME        =',SYSTEM_VOLUME()
C            WRITE(*,*)
C            WRITE(*,*) 'COMOPONENT          CHEMICAL POTENTIAL'
            WRITE(1,*) 'TEMPERATURE  =', TEMPERATURE()
            WRITE(1,*) 'PRESSURE     =', PRESSURE()
            WRITE(1,*)
            WRITE(1,*) 'SYSTEM GIBBS ENERGY  =', SYSTEM_GIBBS_ENERGY()
            WRITE(1,*) 'SYSTEM ENTHALPY      =',SYSTEM_ENTHALPY()
            WRITE(1,*) 'SYSTEM ENTROPY       =', SYSTEM_ENTROPY()
            WRITE(1,*) 'SYSTEM VOLUME        =',SYSTEM_VOLUME()
            WRITE(1,*)
            WRITE(1,*) 'COMOPONENT          CHEMICAL POTENTIAL'
            
            
            DO 30 I=1,ACT_NO_OF_COMPONENTS()
C               WRITE(*,*)ACT_COMPONENT_NAME(I),
C     &              PARTIAL_SYSTEM_GIBBS_ENERGY(I)
               WRITE(1,*)ACT_COMPONENT_NAME(I),
     &              PARTIAL_SYSTEM_GIBBS_ENERGY(I)
 30         CONTINUE
            
            
C            WRITE(*,*)
            WRITE(*,*) 'NUMBER OF STABLE PHASES =  ',
     &           EQUIL_NO_OF_PHASES()
            WRITE(*,*)
            
            WRITE(1,*)
            WRITE(1,*) 'NUMBER OF STABLE PHASES =  ',
     &           EQUIL_NO_OF_PHASES()
            WRITE(1,*)
            
            TOTAL_MOLES=0.0
            
            
            DO 994 I=1,ACT_NO_OF_PHASES()
               
               TOTAL_MOLES=TOTAL_MOLES+
     &              MOLES_OF_COMPONENTS_IN_PHASE(I,ACTIVE)
               
 994        CONTINUE
            



C            PPT_FILE='ppt_fra_'//FILE1
             PPT_FILE='ppt_fraction_check'

            OPEN(UNIT=3,FILE=PPT_FILE)
            OPEN(UNIT=993,FILE='pptates_only')
            WRITE(3,*)'----------------------------------'
            WRITE(3,*)'        COMPOSITION ', AR_I
            WRITE(3,*)'----------------------------------'
            DO 20 I=1,ACT_NO_OF_PHASES()

C               IF(MASS_IN_PHASE(I,ACTIVE).NE.0.0D0) THEN
 
C               WRITE(*,*)
               WRITE(*,9993) ACT_PHASE_NAME(I),
     &              MASS_IN_PHASE(I,ACTIVE)

 9993          FORMAT('MASS OF PHASE ',3X,A,'=',10F)

C               WRITE(*,*)
               WRITE(1,*) 
               WRITE(1,*)'----------------------------------------------
     & -------------'
               WRITE(1,*) 'MASS OF ', ACT_PHASE_NAME(I),'=  ',
     &              MASS_IN_PHASE(I,ACTIVE)
               WRITE(1,*) 'MOLES OF ', ACT_PHASE_NAME(I),'=  ',
     &              MOLES_OF_COMPONENTS_IN_PHASE(I,ACTIVE)
               WRITE(1,*)'TOTAL MOLES OF ALL THE PHASES = ',
     &              TOTAL_MOLES
               WRITE(1,*) 'MOLE FRACTION OF ', ACT_PHASE_NAME(I),'=  ',
     &              MOLES_OF_COMPONENTS_IN_PHASE(I,ACTIVE)/TOTAL_MOLES
               WRITE(3,'(A16,F15.9)') ACT_PHASE_NAME(I), 
     &              MOLES_OF_COMPONENTS_IN_PHASE(I,ACTIVE)/TOTAL_MOLES
               WRITE(993,'(F15.9)')
     &              MOLES_OF_COMPONENTS_IN_PHASE(I,ACTIVE)/TOTAL_MOLES
               
               WRITE(1,*)'----------------------------------------------
     & -------------'  
               WRITE(1,*) 
               


               DO 50 J=1,ACT_NO_OF_COMPONENTS()                  
                  IF (MASS_IN_PHASE(I,ACTIVE) .NE. 0.0) THEN
C                        WRITE(*,*) 'MASS FRACTION OF  ',
C     &                    ACT_COMPONENT_NAME(J),'= ',
C     &                    COMPONENT_W_OF_PHASE(J,I,ACTIVE)
                        
                        
                        WRITE(1,*) 'MASS FRACTION OF ',
     &                       ACT_COMPONENT_NAME(J),'= ',
     &                       COMPONENT_W_OF_PHASE(J,I,ACTIVE)
                     ENDIF
 50               CONTINUE

                  
                  
                  WRITE(*,*)
                  WRITE(1,*)
                  


                  DO 51 J=1,ACT_NO_OF_COMPONENTS()
                     IF (MOLES_OF_COMPONENTS_IN_PHASE(I,ACTIVE) .NE. 
     &                    0.0) THEN
C                        WRITE(*,*)'MOLE FRACTION OF',
C     &                       ACT_COMPONENT_NAME(J),'=',
C     &                       COMPONENT_X_OF_PHASE(J,I,ACTIVE)
                        
                        WRITE(1,*)'MOLE FRACTION OF ',
     &                       ACT_COMPONENT_NAME(J),'= ',
     &                       COMPONENT_X_OF_PHASE(J,I,ACTIVE)

CC==================================================================================
CC==================================================================================
CC Assigning the elements in ferrite and precipitates that are in equilibrium 
CC with the precipitates for calculation of stability parameter
CC==================================================================================
CC==================================================================================
                        IF (ACT_PHASE_NAME(I) .EQ. 'BCC_A2') THEN
                           
                           IF (ACT_COMPONENT_NAME(J) .EQ. 'Cr') THEN
                              bcc_cr=COMPONENT_X_OF_PHASE(J,I,ACTIVE)
                           ENDIF
                           
                           IF (ACT_COMPONENT_NAME(J) .EQ. 'W') THEN
                              bcc_w=COMPONENT_X_OF_PHASE(J,I,ACTIVE)
                           ENDIF

                           IF (ACT_COMPONENT_NAME(J) .EQ. 'Nb') THEN
                              bcc_nb=COMPONENT_X_OF_PHASE(J,I,ACTIVE)
                           ENDIF
                           
                           IF (ACT_COMPONENT_NAME(J) .EQ. 'Mo') THEN
                              bcc_mo=COMPONENT_X_OF_PHASE(J,I,ACTIVE)
                           ENDIF

                           IF (ACT_COMPONENT_NAME(J) .EQ. 'V') THEN
                              bcc_v=COMPONENT_X_OF_PHASE(J,I,ACTIVE)
                           ENDIF
                           
                           IF (ACT_COMPONENT_NAME(J) .EQ. 'Mn') THEN
                              bcc_mn=COMPONENT_X_OF_PHASE(J,I,ACTIVE)
                           ENDIF
                        ENDIF
                        
                        IF (ACT_PHASE_NAME(I) .EQ. 'M23C6') THEN
                           IF (ACT_COMPONENT_NAME(J) .EQ. 'Cr') THEN
                           m23c6_cr=COMPONENT_X_OF_PHASE(J,I,ACTIVE)
                           ENDIF
                           IF (ACT_COMPONENT_NAME(J) .EQ. 'Mo') THEN
                           m23c6_mo=COMPONENT_X_OF_PHASE(J,I,ACTIVE)
                           ENDIF                     
                           IF (ACT_COMPONENT_NAME(J) .EQ. 'Mn') THEN
                           m23c6_mn=COMPONENT_X_OF_PHASE(J,I,ACTIVE)
                           ENDIF                           
                           IF (ACT_COMPONENT_NAME(J) .EQ. 'W') THEN
                           m23c6_w=COMPONENT_X_OF_PHASE(J,I,ACTIVE)
                           ENDIF                           
      
                        ENDIF

                        IF (ACT_PHASE_NAME(I) .EQ. 'M6C') THEN
                           IF (ACT_COMPONENT_NAME(J) .EQ. 'W') THEN
                              m6c_w=COMPONENT_X_OF_PHASE(J,I,ACTIVE)
                           ENDIF
                           IF (ACT_COMPONENT_NAME(J) .EQ. 'Mo') THEN
                              m6c_mo=COMPONENT_X_OF_PHASE(J,I,ACTIVE)
                           ENDIF

                        ENDIF

                        
                        IF (ACT_PHASE_NAME(I) .EQ. 'LAVES_PHASE') THEN
                           IF (ACT_COMPONENT_NAME(J) .EQ. 'W') THEN
                            laves_w=COMPONENT_X_OF_PHASE(J,I,ACTIVE)
                           ENDIF
                           IF (ACT_COMPONENT_NAME(J) .EQ. 'Mo') THEN
                              laves_mo=COMPONENT_X_OF_PHASE(J,I,ACTIVE)
                           ENDIF

                           IF (ACT_COMPONENT_NAME(J) .EQ. 'Cr') THEN
                              laves_cr=COMPONENT_X_OF_PHASE(J,I,ACTIVE)
                           ENDIF
                           IF (ACT_COMPONENT_NAME(J) .EQ. 'Nb') THEN
                              laves_nb=COMPONENT_X_OF_PHASE(J,I,ACTIVE)
                           ENDIF
                        ENDIF

                        IF (ACT_PHASE_NAME(I) .EQ. 'HCP_A3') THEN
                           IF (ACT_COMPONENT_NAME(J) .EQ. 'W') THEN
                           hcpa3_w=COMPONENT_X_OF_PHASE(J,I,ACTIVE)
                           ENDIF
                           IF (ACT_COMPONENT_NAME(J) .EQ. 'Mo') THEN
                           hcpa3_mo=COMPONENT_X_OF_PHASE(J,I,ACTIVE)
                           ENDIF                           
                           IF (ACT_COMPONENT_NAME(J) .EQ. 'Mn') THEN
                           hcpa3_mn=COMPONENT_X_OF_PHASE(J,I,ACTIVE)
                           ENDIF                           
                           IF (ACT_COMPONENT_NAME(J) .EQ. 'Cr') THEN
                           hcpa3_cr=COMPONENT_X_OF_PHASE(J,I,ACTIVE)
                           ENDIF                           

                        ENDIF

                        IF (ACT_PHASE_NAME(I) .EQ. 'M7C3') THEN
                           IF (ACT_COMPONENT_NAME(J) .EQ. 'Mo') THEN
                           m7c3_mo=COMPONENT_X_OF_PHASE(J,I,ACTIVE)
                           ENDIF                           
                           IF (ACT_COMPONENT_NAME(J) .EQ. 'Mn') THEN
                           m7c3_mn=COMPONENT_X_OF_PHASE(J,I,ACTIVE)
                           ENDIF                           
                           IF (ACT_COMPONENT_NAME(J) .EQ. 'Cr') THEN
                           m7c3_cr=COMPONENT_X_OF_PHASE(J,I,ACTIVE)
                           ENDIF                           
                        ENDIF

                        IF (ACT_PHASE_NAME(I) .EQ. 'CNb') THEN
                           IF (ACT_COMPONENT_NAME(J) .EQ. 'Nb') THEN
                              nbc_nb=COMPONENT_X_OF_PHASE(J,I,ACTIVE)
                           ENDIF
                        ENDIF

                        
                        IF (ACT_PHASE_NAME(I) .EQ. 'NNb') THEN
                           IF (ACT_COMPONENT_NAME(J) .EQ. 'Nb') THEN
                              nbn_nb=COMPONENT_X_OF_PHASE(J,I,ACTIVE)
                           ENDIF
                        ENDIF

                        
                        IF (ACT_PHASE_NAME(I) .EQ. 'NV') THEN
                           IF (ACT_COMPONENT_NAME(J) .EQ. 'V') THEN
                              nv_v=COMPONENT_X_OF_PHASE(J,I,ACTIVE)
                           ENDIF
                        ENDIF


                        
CC==================================================================================
CC equilibrium compositions in ferrite and precipitates calculated - END
CC==================================================================================




                     ENDIF
 51               CONTINUE
                  
                  
C                  WRITE(*,*)
C                  WRITE(*,*)

                  DO 993 J=1,ACT_NO_OF_COMPONENTS()
                     IF(COMPONENT_MOLES_IN_PHASE(J,I,ACTIVE) .NE. 0.0) 
     &                    THEN
                        
                        WRITE(1,*)'MOLES OF         ',
     &                       ACT_COMPONENT_NAME(J),'=',
     &                       COMPONENT_MOLES_IN_PHASE(J,I,ACTIVE)
                     ENDIF
                     
C
C
C -------------     COMPONENT CALCULATION IN PHASES STARTS HERE ----------------
C
C
C
                     IF(ACT_PHASE_NAME(I) .EQ. 'BCC_A2') THEN
                        SLNI=1

                        IF(ACT_COMPONENT_NAME(J) .EQ. 'Cr') THEN
                           WRITE(*,9992)ACT_COMPONENT_NAME(J), 
     &      ACT_PHASE_NAME(I),COMPONENT_MASS_IN_PHASE(J,I,ACTIVE)
                           WRITE(*,9997)ACT_COMPONENT_NAME(J), 
     &      ACT_PHASE_NAME(I),COMPONENT_X_OF_PHASE(J,I,ACTIVE)


                           SOLID_SOLN(SLNI)=
     &                          COMPONENT_MASS_IN_PHASE(J,I,ACTIVE)
C                           WRITE(*,*) SOLID_SOLN(SLNI)

                        ENDIF

                        SLNI=SLNI+1

                        IF(ACT_COMPONENT_NAME(J) .EQ. 'Mo') THEN
                           WRITE(*,9992)ACT_COMPONENT_NAME(J), 
     &      ACT_PHASE_NAME(I),COMPONENT_MASS_IN_PHASE(J,I,ACTIVE)
                           WRITE(*,9997)ACT_COMPONENT_NAME(J), 
     &      ACT_PHASE_NAME(I),COMPONENT_X_OF_PHASE(J,I,ACTIVE)


                           SOLID_SOLN(SLNI)=
     &                          COMPONENT_MASS_IN_PHASE(J,I,ACTIVE)
C                           WRITE(*,*) SOLID_SOLN(SLNI)



                        ENDIF

                        SLNI=SLNI+1
                        IF(ACT_COMPONENT_NAME(J) .EQ. 'W') THEN
                           WRITE(*,9992)ACT_COMPONENT_NAME(J), 
     &      ACT_PHASE_NAME(I),COMPONENT_MASS_IN_PHASE(J,I,ACTIVE)
                           WRITE(*,9997)ACT_COMPONENT_NAME(J), 
     &      ACT_PHASE_NAME(I),COMPONENT_X_OF_PHASE(J,I,ACTIVE)

                           SOLID_SOLN(SLNI)=
     &                          COMPONENT_MASS_IN_PHASE(J,I,ACTIVE)
C                           WRITE(*,*) SOLID_SOLN(SLNI)



                        ENDIF
                        SLNI=SLNI+1

                        IF(ACT_COMPONENT_NAME(J) .EQ. 'V') THEN
                           WRITE(*,9992)ACT_COMPONENT_NAME(J), 
     &      ACT_PHASE_NAME(I),COMPONENT_MASS_IN_PHASE(J,I,ACTIVE)
                           WRITE(*,9997)ACT_COMPONENT_NAME(J), 
     &      ACT_PHASE_NAME(I),COMPONENT_X_OF_PHASE(J,I,ACTIVE)

                           SOLID_SOLN(SLNI)=
     &                          COMPONENT_MASS_IN_PHASE(J,I,ACTIVE)
C                           WRITE(*,*) SOLID_SOLN(SLNI)



                        ENDIF

                        SLNI=SLNI+1
                        IF(ACT_COMPONENT_NAME(J) .EQ. 'Nb') THEN
                           WRITE(*,9992)ACT_COMPONENT_NAME(J), 
     &      ACT_PHASE_NAME(I),COMPONENT_MASS_IN_PHASE(J,I,ACTIVE)
                           WRITE(*,9997)ACT_COMPONENT_NAME(J), 
     &      ACT_PHASE_NAME(I),COMPONENT_X_OF_PHASE(J,I,ACTIVE)

                           SOLID_SOLN(SLNI)=
     &                          COMPONENT_MASS_IN_PHASE(J,I,ACTIVE)
C                           WRITE(*,*) SOLID_SOLN(SLNI)

                           
                           
                        ENDIF

                        SLNI=SLNI+1
                        IF(ACT_COMPONENT_NAME(J) .EQ. 'N') THEN
                           WRITE(*,9992)ACT_COMPONENT_NAME(J), 
     &      ACT_PHASE_NAME(I),COMPONENT_MASS_IN_PHASE(J,I,ACTIVE)
                           WRITE(*,9997)ACT_COMPONENT_NAME(J), 
     &      ACT_PHASE_NAME(I),COMPONENT_X_OF_PHASE(J,I,ACTIVE)

                           SOLID_SOLN(SLNI)=
     &                          COMPONENT_MASS_IN_PHASE(J,I,ACTIVE)
C                           WRITE(*,*) SOLID_SOLN(SLNI)
                           
                           
                        ENDIF

                        SLNI=SLNI+1
 
                       IF(ACT_COMPONENT_NAME(J) .EQ. 'C') THEN
                           WRITE(*,9992)ACT_COMPONENT_NAME(J), 
     &      ACT_PHASE_NAME(I),COMPONENT_MASS_IN_PHASE(J,I,ACTIVE)
                           WRITE(*,9997)ACT_COMPONENT_NAME(J), 
     &      ACT_PHASE_NAME(I),COMPONENT_X_OF_PHASE(J,I,ACTIVE)

                           SOLID_SOLN(SLNI)=
     &                          COMPONENT_MASS_IN_PHASE(J,I,ACTIVE)
C                           WRITE(*,*) SOLID_SOLN(SLNI)
                        ENDIF

                        
 9992    FORMAT(5X, 'Mass of Component',3X,A,'in',1X,A,'=',10F)
 9997    FORMAT(5X, 'Mole fraction of Component',3X,A,'in',1X,A,'=',10F)
         
                     ENDIF

                     IF(ACT_PHASE_NAME(I) .EQ. 'M23C6'
     &  .AND. MASS_IN_PHASE(I,ACTIVE) .NE. 0) THEN
                        IF(ACT_COMPONENT_NAME(J) .EQ. 'Cr' 
     &                .OR. ACT_COMPONENT_NAME(J) .EQ. 'Mo' 
     &                .OR. ACT_COMPONENT_NAME(J) .EQ. 'W' 
     &                .OR. ACT_COMPONENT_NAME(J) .EQ. 'Mn') THEN
                           WRITE(*,9997)ACT_COMPONENT_NAME(J), 
     &      ACT_PHASE_NAME(I),COMPONENT_X_OF_PHASE(J,I,ACTIVE)
                        ENDIF
                     ENDIF


                     IF(ACT_PHASE_NAME(I) .EQ. 'M6C' 
     &  .AND. MASS_IN_PHASE(I,ACTIVE) .NE. 0) THEN
                        IF(ACT_COMPONENT_NAME(J) .EQ. 'W' 
     &                .OR. ACT_COMPONENT_NAME(J) .EQ. 'Mo') THEN
                           WRITE(*,9997)ACT_COMPONENT_NAME(J), 
     &      ACT_PHASE_NAME(I),COMPONENT_X_OF_PHASE(J,I,ACTIVE)
                        ENDIF
                     ENDIF


                     IF(ACT_PHASE_NAME(I) .EQ. 'LAVES_PHASE' 
     &  .AND. MASS_IN_PHASE(I,ACTIVE) .NE. 0) THEN
                        IF(ACT_COMPONENT_NAME(J) .EQ. 'W' 
     &                .OR. ACT_COMPONENT_NAME(J) .EQ. 'Mo' 
     &                .OR. ACT_COMPONENT_NAME(J) .EQ. 'Cr') THEN
                           WRITE(*,9997)ACT_COMPONENT_NAME(J), 
     &      ACT_PHASE_NAME(I),COMPONENT_X_OF_PHASE(J,I,ACTIVE)
                        ENDIF
                     ENDIF


                     IF(ACT_PHASE_NAME(I) .EQ. 'HCP_A3' 
     &  .AND. MASS_IN_PHASE(I,ACTIVE) .NE. 0) THEN
                        IF(ACT_COMPONENT_NAME(J) .EQ. 'W'
     &                .OR. ACT_COMPONENT_NAME(J) .EQ. 'Mn'
     &                .OR. ACT_COMPONENT_NAME(J) .EQ. 'Cr'
     &                .OR. ACT_COMPONENT_NAME(J) .EQ. 'Mo') THEN
                           WRITE(*,9997)ACT_COMPONENT_NAME(J), 
     &      ACT_PHASE_NAME(I),COMPONENT_X_OF_PHASE(J,I,ACTIVE)
                        ENDIF
                     ENDIF


                     IF(ACT_PHASE_NAME(I) .EQ. 'NV' 
     &  .AND. MASS_IN_PHASE(I,ACTIVE) .NE. 0) THEN
                        IF(ACT_COMPONENT_NAME(J) .EQ. 'V') THEN
                           WRITE(*,9997)ACT_COMPONENT_NAME(J), 
     &      ACT_PHASE_NAME(I),COMPONENT_X_OF_PHASE(J,I,ACTIVE)
                        ENDIF
                     ENDIF


                     IF(ACT_PHASE_NAME(I) .EQ. 'CNb'
     &  .AND. MASS_IN_PHASE(I,ACTIVE) .NE. 0) THEN
                        IF(ACT_COMPONENT_NAME(J) .EQ. 'Nb') THEN
                           WRITE(*,9997)ACT_COMPONENT_NAME(J), 
     &      ACT_PHASE_NAME(I),COMPONENT_X_OF_PHASE(J,I,ACTIVE)
                        ENDIF
                     ENDIF

                     IF(ACT_PHASE_NAME(I) .EQ. 'NNb'
     &  .AND. MASS_IN_PHASE(I,ACTIVE) .NE. 0) THEN
                        IF(ACT_COMPONENT_NAME(J) .EQ. 'Nb') THEN
                           WRITE(*,9997)ACT_COMPONENT_NAME(J), 
     &      ACT_PHASE_NAME(I),COMPONENT_X_OF_PHASE(J,I,ACTIVE)
                        ENDIF
                     ENDIF

                     IF(ACT_PHASE_NAME(I) .EQ. 'M7C3'
     &  .AND. MASS_IN_PHASE(I,ACTIVE) .NE. 0) THEN
                        IF(ACT_COMPONENT_NAME(J) .EQ. 'Mn'
     &                .OR. ACT_COMPONENT_NAME(J) .EQ. 'Cr'
     &                .OR. ACT_COMPONENT_NAME(J) .EQ. 'Mo') THEN
                           WRITE(*,9997)ACT_COMPONENT_NAME(J), 
     &      ACT_PHASE_NAME(I),COMPONENT_X_OF_PHASE(J,I,ACTIVE)
                        ENDIF
                     ENDIF



CC===
C -------------     COMPONENT CALCULATION IN PHASES ENDS HERE ----------------
CC===
                     
 993              CONTINUE

                  
 20            CONTINUE


                  WRITE (*,*)'****************************************'
                  WRITE (*,*) 'Ratio of element diffusivity to 
     &diffusivity of Iron'
                  WRITE(*,*)
                  WRITE (*,9996) Rcr,Rw,Rv,Rnb,Rmo,Rmn
 9996             FORMAT('----------------------------------------',/,
     &            'Rcr :',F7.3,' Rw :',F7.3,' Rv :',F7.3,
     &            ' Rnb :',F7.3, ' Rmo :',F7.3, ' Rmn :',F7.3)                  
                  WRITE (*,9998) bcc_cr,bcc_w,bcc_nb,bcc_mo,bcc_v,
     &            bcc_mn

 9998             FORMAT('bcc_cr ',E15.3,' bcc_w ',E15.3,' bcc_nb ',
     & E15.3,' bcc_mo ',E15.3,' bcc_v ',E15.3,' bcc_mn ',E15.3)
  
                  WRITE (*,9999) m23c6_cr,m23c6_mo,m23c6_mn,m23c6_w,
     & m6c_w,m6c_mo,laves_w, laves_mo,hcpa3_w,hcpa3_mo,hcpa3_mn,
     & hcpa3_cr,nbc_nb,nbn_nb,nv_v

 9999             FORMAT('m23c6_cr ',E15.3,' m23c6_mo ',E15.3,/,
     & ' m23c6_mn ', E15.3,' m23c6_w ',E15.3,' m6c_w ',E15.3,/,
     & ' m6c_mo ',E15.3,' laves_w ',E15.3,' laves_mo ',E15.3,/,
     & ' hcpa3_w ',E15.3,' hcpa3_mo ',E15.3,' hcpa3_mn ',E15.3,/,
     & ' hcpa3_cr ',E15.3,' nbc_nb ',E15.3,' nbn_nb ',E15.3, 
     & ' nv_v ',E15.3,)

                  WRITE (*,*)'****************************************'
                  
                  IF (TEMPERATURE() .LE. 1033) THEN
                     Dfe=0.5*0.0001
                     WRITE(1,*)
                     WRITE (1,*) "FERROMAGNETIC IRON Dfe (m^2/s):",Dfe 
                     WRITE(1,*)
                  ELSE
                     Dfe=1.6*0.0001

                     WRITE (*,*) "PARAMAGNETIC IRON Dfe (m^2/s):",Dfe 
                     WRITE (1,*) "PARAMAGNETIC IRON Dfe (m^2/s):",Dfe 

                  ENDIF

                  T=TEMPERATURE()

                  Dcr=Dfe*Rcr*exp(-Q/(R*T))
                  Dw=Dfe*Rw*exp(-Q/(R*T))
                  Dv=Dfe*Rv*exp(-Q/(R*T))
                  Dnb=Dfe*Rnb*exp(-Q/(R*T))
                  Dmo=Dfe*Rmo*exp(-Q/(R*T))
                  Dmn=Dfe*Rmn*exp(-Q/(R*T))


CC######################################################################################
CC
CC                              CALCULATION OF 1/Deff
CC
CC=======================================================================================
CC                  
CC If a particular element in zero then its amount in BCC is zero and hence 1/Deff becomes
CC infinity. And so it has been assigned zero.
CC
CC=======================================================================================
CC

                     one_by_Deff_m23c6=(((1/Dcr)*(m23c6_cr-bcc_cr)**2)
     &            /(bcc_cr-bcc_cr**2))+(((1/Dmo)*(m23c6_mo-bcc_mo)**2)
     &            /(bcc_mo-bcc_mo**2))+(((1/Dmn)*(m23c6_mn-bcc_mn)**2)
     &            /(bcc_mn-bcc_mn**2))+(((1/Dw)*(m23c6_w-bcc_w)**2)
     &            /(bcc_w-bcc_w**2))


                  IF(bcc_cr .NE. 0 .AND. bcc_mo .NE. 0
     & .AND. bcc_w .NE. 0 .AND. bcc_mn .NE. 0) THEN
                     Deff_m23c6=1/one_by_Deff_m23c6
                  ELSE
                     Deff_m23c6=0.0                     
                  ENDIF


                  one_by_Deff_m6c=(((1/Dw)*(m6c_w-bcc_w)**2)
     &            /(bcc_w-bcc_w**2))+(((1/Dmo)*(m6c_mo-bcc_mo)**2)
     &            /(bcc_mo-bcc_mo**2))


                  IF(bcc_w .NE. 0 .AND. 
     & bcc_mo .NE. 0 ) THEN
                  Deff_m6c=1/one_by_Deff_m6c
                  ELSE
                     Deff_m6c = 0.0
                  ENDIF

                     one_by_Deff_laves=(((1/Dw)*(laves_w-bcc_w)**2)
     &            /(bcc_w-bcc_w**2))+(((1/Dmo)*(laves_mo-bcc_mo)**2)
     &            /(bcc_mo-bcc_mo**2))+(((1/Dcr)*(laves_cr-bcc_cr)**2)
     &            /(bcc_cr-bcc_cr**2))+(((1/Dnb)*(laves_nb-bcc_nb)**2)
     &            /(bcc_nb-bcc_nb**2))



                  IF(bcc_cr .NE. 0 .AND. bcc_mo .NE. 0
     & .AND. bcc_w .NE. 0 .AND. bcc_nb .NE. 0 ) THEN
                  Deff_laves=1/one_by_Deff_laves

                  ELSE
                     Deff_laves = 0.0
                  ENDIF


                     one_by_Deff_hcpa3=(((1/Dw)*(hcpa3_w-bcc_w)**2)
     &            /(bcc_w-bcc_w**2))+(((1/Dmo)*(hcpa3_mo-bcc_mo)**2)
     &            /(bcc_mo-bcc_mo**2))+(((1/Dmn)*(hcpa3_mn-bcc_mn)**2)
     &            /(bcc_mn-bcc_mn**2))+(((1/Dcr)*(hcpa3_cr-bcc_cr)**2)
     &            /(bcc_cr-bcc_cr**2))

                  
                  IF(bcc_w .NE. 0 .AND. bcc_mo .NE. 0
     & .AND. bcc_mn .NE. 0 .AND. bcc_cr .NE. 0 ) THEN
                  Deff_hcpa3=1/one_by_Deff_hcpa3
                  ELSE
                     Deff_hcpa3 = 0.0
                  ENDIF


                     one_by_Deff_m7c3=(((1/Dmo)*(m7c3_mo-bcc_mo)**2)
     &            /(bcc_mo-bcc_mo**2))+(((1/Dmn)*(m7c3_mn-bcc_mn)**2)
     &            /(bcc_mn-bcc_mn**2))+(((1/Dcr)*(m7c3_cr-bcc_cr)**2)
     &            /(bcc_cr-bcc_cr**2))



                  IF(bcc_mo .NE. 0
     & .AND. bcc_mn .NE. 0 .AND. bcc_cr .NE. 0 ) THEN
                  Deff_m7c3=1/one_by_Deff_m7c3
                  ELSE
                     Deff_m7c3 = 0.0
                  ENDIF


                     one_by_Deff_vn=(((1/Dv)*(nv_v-bcc_v)**2)
     &            /(bcc_v-bcc_v**2))



                  IF (bcc_v .NE. 0) THEN                     
                  Deff_vn=1/one_by_Deff_vn
                  ELSE
                     Deff_vn=0.0
                  ENDIF

                     one_by_Deff_nbc=(((1/Dnb)*(nbc_nb-bcc_nb)**2)
     &            /(bcc_nb-bcc_nb**2))
                     one_by_Deff_nbn=(((1/Dnb)*(nbn_nb-bcc_nb)**2)
     &            /(bcc_nb-bcc_nb**2))


                  IF (bcc_nb .NE. 0) THEN                     
                  Deff_nbc=1/one_by_Deff_nbc
                  Deff_nbn=1/one_by_Deff_nbn
                  ELSE
                     Deff_nbc=0.0
                     Deff_nbn=0.0
                     
                  ENDIF
                     
                  

                  WRITE(*,*)'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~'
                  WRITE(*,9995) Dcr,Dmo,Dw,Dv, Dnb
 9995             FORMAT('Dcr',E,/,
     &                 'Dmo',E,/
     &                 ,'Dw',E,/,
     &                 'Dv',E,
     &                /, 'DNb',E)
                  
                  WRITE(*,9994) 'one_by_Deff_m23c6', one_by_Deff_m23c6
                  WRITE(*,9994) 'one_by_Deff_m6c', one_by_Deff_m6c
                  WRITE(*,9994) 'one_by_Deff_laves', one_by_Deff_laves
                  WRITE(*,9994) 'one_by_Deff_hcpa3', one_by_Deff_hcpa3
                  WRITE(*,9994) 'one_by_Deff_m7c3', one_by_Deff_m7c3
                  WRITE(*,9994) 'one_by_Deff_vn', one_by_Deff_vn
                  WRITE(*,9994) 'one_by_Deff_nbc', one_by_Deff_nbc
                  WRITE(*,9994) 'one_by_Deff_nbn', one_by_Deff_nbn
                  
                  WRITE(*,9994) 'Deff_m23c6',Deff_m23c6
                  WRITE(*,9994) 'Deff_m6c', Deff_m6c
                  WRITE(*,9994) 'Deff_laves', Deff_laves
                  WRITE(*,9994) 'Deff_hcpa3', Deff_hcpa3
                  WRITE(*,9994) 'Deff_m7c3', Deff_m7c3
                  WRITE(*,9994) 'Deff_vn', Deff_vn
                  WRITE(*,9994) 'Deff_nbc', Deff_nbc
                  WRITE(*,9994) 'Deff_nbn', Deff_nbn

                  WRITE(1,*)

                  WRITE(1,9994) 'one_by_Deff_m23c6', one_by_Deff_m23c6
                  WRITE(1,9994) 'one_by_Deff_m6c', one_by_Deff_m6c
                  WRITE(1,9994) 'one_by_Deff_laves', one_by_Deff_laves
                  WRITE(1,9994) 'one_by_Deff_hcpa3', one_by_Deff_hcpa3
                  WRITE(1,9994) 'one_by_Deff_m7c3', one_by_Deff_m7c3
                  WRITE(1,9994) 'one_by_Deff_vn', one_by_Deff_vn
                  WRITE(1,9994) 'one_by_Deff_nbc', one_by_Deff_nbc
                  WRITE(1,9994) 'one_by_Deff_nbn', one_by_Deff_nbn

                  WRITE(1,*)
                  
                  WRITE(1,9994) 'Deff_m23c6 [Cr MO Mn W]',Deff_m23c6
                  WRITE(1,9994) 'Deff_m6c [Mo W]', Deff_m6c
                  WRITE(1,9994) 'Deff_laves[Mo W Cr Nb]', Deff_laves
                  WRITE(1,9994) 'Deff_hcpa3[W Mo Mn Cr]', Deff_hcpa3
                  WRITE(1,9994) 'Deff_m7c3[Mn Cr Mo]', Deff_m7c3
                  WRITE(1,9994) 'Deff_vn[V]', Deff_vn
                  WRITE(1,9994) 'Deff_nbc[Nb]', Deff_nbc
                  WRITE(1,9994) 'Deff_nbn[Nb]', Deff_nbn


                  WRITE(*,*)'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~'                  
 9994             FORMAT(A,X,':',15E)
                  

                  WRITE(771, 7771) one_by_Deff_m23c6,one_by_Deff_m6c,
     & one_by_Deff_laves, one_by_Deff_hcpa3,one_by_Deff_m7c3, 
     & one_by_Deff_vn,one_by_Deff_nbc,one_by_Deff_nbn

 7771         FORMAT(8('  ',E18.3))
              

              WRITE(772, 7771) Deff_m23c6,Deff_m6c,Deff_laves,
     & Deff_hcpa3,Deff_m7c3,Deff_vn,Deff_nbc,Deff_nbn

 7772         FORMAT(8('  ',E18.3))




               WRITE (*,*) 'Cr ', 'Mo ','W ', 'V ', 'Nb ','N ',' C '
               WRITE(*,*)SOLID_SOLN(1),SOLID_SOLN(2),
     &              SOLID_SOLN(3),SOLID_SOLN(4),
     &              SOLID_SOLN(5),SOLID_SOLN(6),SOLID_SOLN(7)
               
               WRITE(995,9991)SOLID_SOLN(1),SOLID_SOLN(2),
     &              SOLID_SOLN(3),SOLID_SOLN(4),
     &              SOLID_SOLN(5),SOLID_SOLN(6),SOLID_SOLN(7)
               WRITE(1,*)
               WRITE(1,*)
               WRITE(1,*)

               WRITE (1,*) 'AMOUNT of', '  Cr ', 'Mo ','W ',
     &              'V ', 'Nb ','N ', ' C ',  ' in  BCC_A2'
               
               WRITE(1,*)
               
               WRITE(1,9991)SOLID_SOLN(1),SOLID_SOLN(2),
     &              SOLID_SOLN(3),SOLID_SOLN(4),
     &              SOLID_SOLN(5),SOLID_SOLN(6),SOLID_SOLN(7) 
               WRITE(1,*)
               WRITE(1,*)
               WRITE(1,*)
               
               
               
 9991          FORMAT(F15.10,F15.10,F15.10,F15.10,
     &              F15.10,F15.10,F15.10)
               
            ENDIF
 999     CONTINUE
         
      ENDIF
      STOP
      END










